﻿using System;

using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Com.Rscja.Deviceapi;
using Android.Media;
using System.Threading;
namespace Barcode1D_demo
{
	[Activity (Label = "Barcode1D_demo", MainLauncher = true)]
	public class MainActivity : Activity
	{
		Button btnScan;
		Button btnClear;
		TextView tvData;
		Barcode1D barcode;
		ScrollView sclViBarcode;
		SoundPool soundPool;
		int soundPoolId;

		Thread thScan=null;
		AutoResetEvent thEvent=new  AutoResetEvent(false);
		bool isColse=false;
		HandManage handler;

		protected override void OnCreate (Bundle bundle)
		{ 
			base.OnCreate (bundle);

			// Set our view from the "main" layout resource
			SetContentView (Resource.Layout.Main);

			// Get our button from the layout resource,
			// and attach an event to it
			btnScan = FindViewById<Button> (Resource.Id.btnScan);
			btnClear = FindViewById<Button> (Resource.Id.btnClear);
			tvData = FindViewById<TextView> (Resource.Id.tvBarcode);
			sclViBarcode = (ScrollView)FindViewById(Resource.Id.sclViBarcode);

			soundPool = new SoundPool (10, Stream.Music, 0); 
			soundPoolId = soundPool.Load(this,Resource.Drawable.beep, 1);

			btnScan.Click += delegate {
				Scan();
			};
			btnClear.Click += delegate {
				tvData.Text=string.Empty;
			};
			try
			{
				barcode=Barcode1D.Instance;
			}catch{

			}
			handler = new HandManage (this);
		}

		protected override void OnResume()
		{
			base.OnResume ();
			new initBarcode (this).Execute ();
		}
		protected override void OnPause()
		{
			base.OnPause ();
			if (barcode != null)
			{
				barcode.Close ();
			}
		}
		protected override void OnStop()
		{
			base.OnStop ();
			StopScanThread ();
		}




		public override bool OnKeyDown(Keycode code,KeyEvent e)
		{
			if (code == Keycode.F9)
			{
				Scan ();
				return true;
			}
			return base.OnKeyDown (code,e);
		}
		public override bool OnKeyUp(Keycode code,KeyEvent e)
		{
			if (code == Keycode.F9)
			{
				Thread.Sleep (100);
				barcode.StopScan ();
				return true;
			}
			return base.OnKeyUp (code,e);
		}


		public class initBarcode:AsyncTask{

			MainActivity mContext;
			ProgressDialog pro;
			public initBarcode(MainActivity m)
			{
				mContext=m;
			}

			protected override void OnPreExecute()
			{
				pro = new ProgressDialog (mContext);
				pro.SetProgressStyle (ProgressDialogStyle.Spinner);
				pro.SetMessage ("Barcode1D Init...");
				pro.Show ();

			}
			#region implemented abstract members of AsyncTask

			protected override Java.Lang.Object DoInBackground (params Java.Lang.Object[] @params)
			{
				if (mContext.barcode.Open ()) 
				{//throw new NotImplementedException ();
					mContext.StartScanThread ();
					return "OK";
				}
				return "";
			}

			#endregion
			protected override void  OnPostExecute(Java.Lang.Object obj)
			{
				if (obj.ToString() != "OK") {
					Toast.MakeText (mContext,"init failuer",ToastLength.Short).Show();
				}
				pro.Cancel ();
			}
				
		}

		private void scrollToBottom(ScrollView scroller,View tvData)
		{
			int offset = tvData.MeasuredHeight - scroller.Height;

			offset = offset < 0 ? 0 : offset;

			scroller.ScrollTo (0,offset);
		}



		private void StartScanThread()
		{
			if (thScan == null &&  barcode != null) {
				isColse = false;
				thScan = new Thread (BarcodeScan);
				thScan.IsBackground = true;
				thScan.Start ();
			}
		}

		private void StopScanThread()
		{
			if (thScan != null) {
				isColse = true;
				thEvent.Set ();
				Thread.Sleep (100);
				thScan = null;
			}
		}

		public void BarcodeScan()
		{
			while (!isColse) 
			{
				thEvent.WaitOne (-1,false);
				if (isColse)
					return;
				string strData=barcode.Scan ();
				Message msg = new Message ();
				msg.What = 10;
				msg.Obj = strData;
				handler.SendMessage (msg);

			}
		}

		private class HandManage:Handler
		{
			MainActivity mContext;
			public HandManage(MainActivity m)
			{
				mContext=m;
			}
			public override void HandleMessage(Message msg)
			{
				if (msg.What == 10) {
					string data = msg.Obj.ToString ();
					if (data == string.Empty) 
					{
						mContext.tvData.Text = (mContext.tvData.Text+"failuer\r\n");
					}
					else
					{
						mContext.tvData.Text = (mContext.tvData.Text+data+"\r\n");
						mContext.Sound ();
					}
					mContext.scrollToBottom(mContext.sclViBarcode,mContext.tvData);
				}
			}
		}
		 
		private void Scan()
		{
			thEvent.Set ();
		}
		private void Sound()
		{
			//第一个参数为id
			//第二个和第三个参数为左右声道的音量控制
			//第四个参数为优先级，由于只有这一个声音，因此优先级在这里并不重要

			//第五个参数为是否循环播放，0为不循环，-1为循环
			//
			//最后一个参数为播放比率，从0.5到2，一般为1，表示正常播放。
			soundPool.Play(soundPoolId,1, 1, 0, 0, 1);


		}

	}
}


